<?php
/**
 * The template to display the logo or the site name and the slogan in the Header
 *
 * @package WordPress
 * @subpackage NETMIX
 * @since NETMIX 1.0
 */

$netmix_args = get_query_var( 'netmix_logo_args' );

// Site logo
$netmix_logo_type   = isset( $netmix_args['type'] ) ? $netmix_args['type'] : '';
$netmix_logo_image  = netmix_get_logo_image( $netmix_logo_type );
$netmix_logo_text   = netmix_is_on( netmix_get_theme_option( 'logo_text' ) ) ? get_bloginfo( 'name' ) : '';
$netmix_logo_slogan = get_bloginfo( 'description', 'display' );
if ( ! empty( $netmix_logo_image['logo'] ) || ! empty( $netmix_logo_text ) ) {
	?><a class="sc_layouts_logo" href="<?php echo esc_url( home_url( '/' ) ); ?>">
		<?php
		if ( ! empty( $netmix_logo_image['logo'] ) ) {
			if ( empty( $netmix_logo_type ) && function_exists( 'the_custom_logo' ) && is_numeric( $netmix_logo_image['logo'] ) && $netmix_logo_image['logo'] > 0 ) {
				the_custom_logo();
			} else {
				$netmix_attr = netmix_getimagesize( $netmix_logo_image['logo'] );
				echo '<img src="' . esc_url( $netmix_logo_image['logo'] ) . '"'
						. ( ! empty( $netmix_logo_image['logo_retina'] ) ? ' srcset="' . esc_url( $netmix_logo_image['logo_retina'] ) . ' 2x"' : '' )
						. ' alt="' . esc_attr( $netmix_logo_text ) . '"'
						. ( ! empty( $netmix_attr[3] ) ? ' ' . wp_kses_data( $netmix_attr[3] ) : '' )
						. '>';
			}
		} else {
			netmix_show_layout( netmix_prepare_macros( $netmix_logo_text ), '<span class="logo_text">', '</span>' );
			netmix_show_layout( netmix_prepare_macros( $netmix_logo_slogan ), '<span class="logo_slogan">', '</span>' );
		}
		?>
	</a>
	<?php
}
